package Globals;

import java.io.*;       //Only to read from URL.
import java.net.*;      //Only to read from URL.






//**********************************************
/** Global Utility Class */
public final class GU{
//**********************************************

 public static  String[] resource;
 public static       int resourceLength;
 private static   String resourceString;
 private static String[] log = new String[1000];

 /**<pre>      
    This method try to use jar to retrieve the resource.
    If this approach fails, then resource is read from normal
    tree in the root of index.htm web page.

                   jar is something I cannot rely on yet:
                   I would not be able to find quick and clear docs.
                   Some say this:
                   ob.getClass().getResource(relativePath);
                   Some say this:
                   ob.getClass().getClassLoader().getResource(relativePath);
                   I found that when I prepend "/" to the relative path,
                   the method begins working. 
 
                   This "../Resources/" + FileName 
                   and this "Resources/" + FileName 
                   were not successfull.
 
                   But, I cannot rely in try and see method ...
                   This is why this proc., getResource, is so clumsy and have 
                   so redundant checkers ...
     
         do1b do Container ob ? to speed up the cast? 

</pre> */
 public static String getResource(
                       URL codebase, 
                       String FileName,
                       int typeOfResource, 
                       Object ob) {

   boolean gettingResourceFailed = false;
   boolean tryWithoutJar = false;
   URL url = null;
   URLConnection urlConn = null;
   String relativePath   = "/Resources/" + FileName;
   log[0]                = " ";
   int           logIx   = 0;
   String            s   = "";
   int lineIx            = -1;

   if( typeOfResource != 2 ) resource = new String[1000];

   if( 1 != typeOfResource ) {
       tryWithoutJar = true;
   }else{
       log[++logIx] = "Trying jar for rel. path=" + relativePath;
       log[++logIx] = "Object with resource is = " + ob;
       try{ url =  ob.getClass().getResource(relativePath);
       }catch( Error e ) {
            log[++logIx] = "Problems getting resource:";
            log[++logIx] = "Error is: " + e;
            tryWithoutJar = true;
       }catch( Exception e ) {
            log[++logIx] = "Problems getting resource:";
            log[++logIx] = "Exception is: " + e;
            tryWithoutJar = true;
       }

       /*
         //InputStream in = ob.getClass().getResourceAsStream("relativePath");
           InputStreamReader in = ob.getClass().getResourceAsStream("relativePath");
         try{
         BufferedReader br = 
             new BufferedReader(
                 in
             );
       */
       if( !tryWithoutJar ) {
           if( url == null ){
               tryWithoutJar = true;
               log[++logIx] = "Tried to open url, still null ... ";
           }
       } 
   }


   //Try url not from jar:
   if( tryWithoutJar) {
       if( 2 == typeOfResource ) {
           relativePath = FileName;
       }else{
           relativePath = "Resources/" + FileName;
       }
       if( 0 == typeOfResource ) log[++logIx] = "Trying without jar: rel. path=" + relativePath;
       try{ url = new URL(codebase, relativePath ); 
       } catch( Throwable e) { //MalformedURLException e ) {
            gettingResourceFailed = true;
            log[++logIx] = "Exception: " + e;
            url = null;
       }
   }

   if( url == null ){
       gettingResourceFailed = true;
       log[++logIx] = "Created url is null yet ... ";
   } 

   if( !gettingResourceFailed ) {
       try { urlConn = url.openConnection(); 
       } catch (Throwable ioe ) { //IOException ioe){ 
             gettingResourceFailed = true;
             log[++logIx] = "Failed to open URL connection: " + ioe.getMessage();
      }
   }




   
   if( !gettingResourceFailed ) {

       //if( GS.deb ) Utility.DisplayConnection( urlConn );
       try{
             BufferedReader br = 
                 new BufferedReader(
                     new InputStreamReader( 
                         urlConn.getInputStream()
                     )
                 );

             if( 2 == typeOfResource ) {
                 resourceString = br.readLine();
             }else{
                 resource[0]= null; //To intiate work. 
                 while( (resource[++lineIx] = br.readLine()) != null ) {
                         //GS.con(resource[i]); //debug
                 }
                 resourceLength = lineIx;
             }
             br.close();

       } catch(IOException ioe) {
             gettingResourceFailed = true;
             log[++logIx] = "Failed to read from URL: " + ioe.getMessage();
       }       
   } //if( !gettingResourceFailed 


   if( gettingResourceFailed ) {
       log[++logIx] = "Resource Deliver from Server failed.";
       resource = log;
       resourceLength = logIx+1;
       if( 2 != typeOfResource ) GS.con(log, logIx);
       return log[logIx-1]; //Try to return most informative message.
   }else{
       //Debug:
       log[++logIx] = "Resource obtained successfully";
       if( 2 != typeOfResource) GS.con(log, logIx);
       return resourceString; 
   }
 } //void getResource(



} //Class end.